﻿// ==UserScript==
// @id          HighlighterMe
// @name        HighlighterMe
// @namespace    
// @include     http*://forum.lazarus.freepascal.org/*
// @author      Cryptos
// @description Prettify lazarus forum [code]
// @version     1.0
// ##run-at     document-start
// @grant       none
// ==/UserScript==

document.addEventListener ("DOMContentLoaded", DOM_ContentReady);
window.addEventListener ("load", pageFullyLoaded);
 
 
function DOM_ContentReady () {
	var cdn='http://alexgorbatchev.com/pub/sh/2.1.364';
	//var cdn='http://alexgorbatchev.com/pub/sh/2.1.382';
	
	var LoadRemoteResource = function( ResourceURI, ResourceType){
		var parent = document.head || document.body || document.documentElement;
		if (ResourceType=='js'){
			var js=document.createElement('script');
			js.setAttribute('type','text/javascript');
			js.setAttribute('src', ResourceURI);
			parent.appendChild(js);
			//console.log ('==> js added', new Date() );
		}
		else if (ResourceType=="css"){
			var css = document.createElement('link');
			css.rel = 'stylesheet';
			css.type = 'text/css';
			css.href = ResourceURI;
			parent.appendChild(css); 
			//console.log ("==> css added", new Date() );
		}
		if (typeof fileref!="undefined"){
			console.log ("==> Unknow resource uri", new Date() );
		}
	};

	// LoadRemoteResource('https://cdnjs.cloudflare.com/ajax/libs/jquery/1.3.2/jquery.min.js', 'js');
	// LoadRemoteResource('https://cdnjs.cloudflare.com/ajax/libs/sizzle/1.4.4/sizzle.min.js', 'js');	
	
	var Lazarus_highlight = function(){
		LoadRemoteResource(cdn+'/scripts/shBrushDelphi.js', 'js');
		
		// Patch page to work with highlighter
		/*
		var pre = document.getElementsByTagName("pre"); 
		for (var i = 0; i < pre.length; i++){ 
		  pre[i].className = 'brush: pas';
		};
		*/
	  
		var code = document.getElementsByTagName("code"); 
		for (var i = 0; i < code.length; i++){ 
		  code[i].className = ' brush: pas';  
		};
	};
	
	var all_highlight = function(){
		LoadRemoteResource(cdn+'/scripts/shBrushAS3.js');
		LoadRemoteResource(cdn+'/scripts/shBrushBash.js');
		LoadRemoteResource(cdn+'/scripts/shBrushCSharp.js');
		LoadRemoteResource(cdn+'/scripts/shBrushColdFusion.js');
		LoadRemoteResource(cdn+'/scripts/shBrushCpp.js');
		LoadRemoteResource(cdn+'/scripts/shBrushCss.js');
		LoadRemoteResource(cdn+'/scripts/shBrushDiff.js');
		LoadRemoteResource(cdn+'/scripts/shBrushErlang.js');
		LoadRemoteResource(cdn+'/scripts/shBrushGroovy.js');
		LoadRemoteResource(cdn+'/scripts/shBrushJScript.js');
		LoadRemoteResource(cdn+'/scripts/shBrushJava.js');
		LoadRemoteResource(cdn+'/scripts/shBrushJavaFX.js');
		LoadRemoteResource(cdn+'/scripts/shBrushPerl.js');
		LoadRemoteResource(cdn+'/scripts/shBrushPhp.js');
		LoadRemoteResource(cdn+'/scripts/shBrushPlain.js');
		LoadRemoteResource(cdn+'/scripts/shBrushPowerShell.js');
		LoadRemoteResource(cdn+'/scripts/shBrushPython.js');
		LoadRemoteResource(cdn+'/scripts/shBrushRuby.js');
		LoadRemoteResource(cdn+'/scripts/shBrushScala.js');
		LoadRemoteResource(cdn+'/scripts/shBrushSql.js');
		LoadRemoteResource(cdn+'/scripts/shBrushVb.js');
		LoadRemoteResource(cdn+'/scripts/shBrushXml.js');
		LoadRemoteResource(cdn+'/scripts/shBrushDelphi.js');			
	};

	// common resources
	LoadRemoteResource(cdn+'/styles/shCore.css', 'css');
	LoadRemoteResource(cdn+'/styles/shThemeRDark.css', 'css');
	LoadRemoteResource(cdn+'/scripts/shCore.js', 'js');
	
	/* //Add support of copy to clipboard
	var js = document.createElement('script');
	js.setAttribute("type", "text/javascript");
	js_text = document.createTextNode('SyntaxHighlighter.config.clipboardSwf = "'+domain+syntaxhighlighter_version+'/scripts/clipboard.swf"; SyntaxHighlighter.all();');
	js.appendChild(js_text);
	head.appendChild(js);
	*/

	//if uri=lazarus {
		Lazarus_highlight();
	//}
	   
};

function pageFullyLoaded () {
	//console.log ("==> Page is fully loaded, including images.", new Date() );
	var Lazarus_highlight = function(){
		//add top border
		var pre = document.getElementsByTagName("pre");
		for (var i=0; i < pre.length; i++){
			/* change <pre></pre> style only if it contains <code></code> */
		    if( pre[i].children[0] != null && pre[i].children[0].tagName == 'CODE' )
				pre[i].setAttribute('style', 'border-top:2px solid #C83838 !important; border-bottom:1px solid #C83838 !important; margin:0px 0px 15px !important; padding:0px 0px 2px 0px !important');			
		};
		SyntaxHighlighter.config.tagName='code';
		SyntaxHighlighter.config.bloggerMode = true; 
		SyntaxHighlighter.all();
		SyntaxHighlighter.highlight();
		
		//correct font size and margin
		var classes = document.getElementsByClassName("syntaxhighlighter"); 
		for (var i = 0; i < classes.length; i++){
			classes[i].setAttribute('style', 'font-size:12px !important; margin:4px 0px 0px 2px !important; overflow:auto !important; max-height:24em !important;');
		};
	};
	
	//if uri=lazarus {
		Lazarus_highlight();
	//}	
};
